#include <cstdlib>
#include <iostream>
#include <ctime>

#include <cstdio>

#include <windows.h>

#include "game.h"

using namespace std;

int main(int argc, char *argv[])
{
	int typeLoading = 0;

	int width ,
	height ,
	amount;

	srand( time( NULL ) );

	Game currentGame;

	switch( typeLoading ){
	case 0:{

			width = 20;
			height = 10;

			amount = rand() % ( width * height ) + 2;

			currentGame.createArray( width , height );

			break;
		}
	case 1:{

			width = rand() % 30 + 5;
			height = rand() % 30 + 5;

			amount = rand() % ( width * height ) + 2;

			currentGame.createArray( width , height );

			break;
		}
	case 2:{

			FILE * filePointer = fopen( "start.txt" , "rt" );

			if( !filePointer ){
				std::cout << "Couldn't open file" << std::endl;

				return 0;
			}

			char dataBuffer;

			int widthBuffer = 0;
			int currentHeight = 0;

			while( !feof( filePointer ) ){
				dataBuffer = fgetc( filePointer );

				if( dataBuffer == EOF ){
					break;
				}

				if( dataBuffer == '\n' ){
					width = widthBuffer;

					widthBuffer = 0;

					currentHeight++;
				}
				else{
					widthBuffer++;
				}
			}

			fclose( filePointer );

			width = widthBuffer;
			height = currentHeight + 1;

			amount = rand() % ( width * height ) + 2;

			filePointer = fopen( "start.txt" , "rt" );

			if( !filePointer ){
				std::cout << "Couldn't open file" << std::endl;

				return 0;
			}

			currentGame.createArray( width , height );

			widthBuffer = 0;
			currentHeight = 0;

			while( !feof( filePointer ) ){
				dataBuffer = fgetc( filePointer );

				if( dataBuffer == EOF ){
					break;
				}

				if( dataBuffer == '\n' ){
					width = widthBuffer;

					widthBuffer = 0;

					currentHeight++;
				}
				else{
					widthBuffer++;
				}

				if( dataBuffer == '1' ){
					currentGame.setPoint( true , widthBuffer - 1, currentHeight );
				}
				else if ( dataBuffer == '0' ){
					currentGame.setPoint( false, widthBuffer - 1 , currentHeight );
				}
				else if ( dataBuffer != '\n' ){
					std::cout << "Unrecognized character" << (int)dataBuffer << std::endl;

					return 0;
				}
			}

			amount = 0;

			break;
		}
	}

	for( int iAmount = 0; iAmount < amount; iAmount++ ){
		currentGame.setPoint( true , rand() % width  , rand() % height );
	}

	while( true ){
		Sleep( 500 );

		currentGame.print();

		currentGame.step();

		std::cout << std::endl;

		if( currentGame.check() ){

			FILE * filePointer = fopen( "Koniec.txt" , "wt" );

			if( !filePointer ){
				return 0;
			}

			std::vector< std::vector< bool > > array = currentGame.getArray();

			for( int iPositionHeight = 0; iPositionHeight < currentGame.getHeight(); iPositionHeight++ ){
				for( int iPosition = 0; iPosition < currentGame.getWidth() ; iPosition++ ){
					if( currentGame.getPoint( iPosition , iPositionHeight ) ){
						fputc( 'X' , filePointer );
					}
					else{
						fputc( '0' , filePointer );
					}
				}

				fputc( '\n' , filePointer );
			}

			fclose( filePointer );

			return 0;
		}

	}

	return EXIT_SUCCESS;
}
