#include <vector>

class Game{
      public:
             Game(){}

             Game( int width , int height ){
                   this -> array.resize( height );

                   for( int iPositionHeight = 0 ; iPositionHeight < height ; iPositionHeight++ ){
                        this -> array[ iPositionHeight ].resize( width );
                   }


                   this -> classWidth = width;
                   this -> classHeight = height;
             }

             void createArray( int width , int height ){
                   this -> array.resize( height );

                   for( int iPositionHeight = 0 ; iPositionHeight < height ; iPositionHeight++ ){
                        this -> array[ iPositionHeight ].resize( width );
                   }


                   this -> classWidth = width;
                   this -> classHeight = height;
             }

             void step(){
                 std::vector< std::vector< bool > > tmpArray;

                 tmpArray.resize( this -> classHeight );

                 for( int iPositionHeight = 0 ; iPositionHeight < this -> classHeight ; iPositionHeight++ ){
                        tmpArray[ iPositionHeight ].resize( this -> classWidth );
                }

                 for( int iPositionHeight = 0 ; iPositionHeight < this -> classHeight; iPositionHeight++ ){
                    for( int iPositionWidth = 0; iPositionWidth < this -> classWidth ; iPositionWidth++ ){
                        int amount = 0;

                        if( this -> getPoint( iPositionWidth , iPositionHeight )  ){
                                if( this -> getPoint( iPositionWidth + 1, iPositionHeight ) ){
                                    amount++;
                                }

                                if( this -> getPoint( iPositionWidth - 1, iPositionHeight ) ){
                                    amount++;
                                }

                                if( this -> getPoint( iPositionWidth, iPositionHeight + 1 ) ){
                                    amount++;
                                }

                                if( this -> getPoint( iPositionWidth, iPositionHeight - 1 ) ){
                                    amount++;
                                }

                                if( this -> getPoint( iPositionWidth + 1, iPositionHeight + 1 ) ){
                                    amount++;
                                }

                                if( this -> getPoint( iPositionWidth + 1, iPositionHeight - 1 ) ){
                                    amount++;
                                }

                                if( this -> getPoint( iPositionWidth - 1, iPositionHeight + 1) ){
                                    amount++;
                                }

                                if( this -> getPoint( iPositionWidth - 1, iPositionHeight - 1 ) ){
                                    amount++;
                                }

                                if( amount == 2 || amount == 3 ){
                                    tmpArray[ iPositionHeight ][ iPositionWidth ] = true;
                                }
                        }
                        else{
                            if( this -> getPoint( iPositionWidth + 1, iPositionHeight ) ){
                                    amount++;
                                }

                                if( this -> getPoint( iPositionWidth - 1, iPositionHeight ) ){
                                    amount++;
                                }

                                if( this -> getPoint( iPositionWidth, iPositionHeight + 1 ) ){
                                    amount++;
                                }

                                if( this -> getPoint( iPositionWidth, iPositionHeight - 1 ) ){
                                    amount++;
                                }

                                if( this -> getPoint( iPositionWidth + 1, iPositionHeight + 1 ) ){
                                    amount++;
                                }

                                if( this -> getPoint( iPositionWidth + 1, iPositionHeight - 1 ) ){
                                    amount++;
                                }

                                if( this -> getPoint( iPositionWidth - 1, iPositionHeight + 1) ){
                                    amount++;
                                }

                                if( this -> getPoint( iPositionWidth - 1, iPositionHeight - 1 ) ){
                                    amount++;
                                }

                                if( amount == 3 ){
                                    tmpArray[ iPositionHeight ][ iPositionWidth ] = true;
                                }
                        }
                    }
                }
                this -> backupSecond = this -> backupFirst;
                this -> backupFirst  = this -> array;

                this -> array        = tmpArray;
             }

             bool check(){
                  if( this -> backupSecond == this -> array ){
                    return true;
                  }

                  int amount = 0;

                  for( int iPositionHeight = 0; iPositionHeight < this -> classHeight; iPositionHeight++ ){
                       for( int iPosition = 0; iPosition < this -> classWidth; iPosition++ ){
                                      if( this -> getPoint( iPosition , iPositionHeight ) ){
                                          amount++;
                                      }
                       }
                  }

                  if( amount == 0 ){
                        return true;
                  }

                  return false;
             }

             bool getPoint( int positionX , int positionY ){
                  if( positionX < 0 || positionX >= classWidth ){
                      return false;
                  }

                  if( positionY < 0 || positionY >= classHeight ){
                      return false;
                  }

                  return this -> array[ positionY ][ positionX ];
             }

             bool setPoint( bool value , int positionX , int positionY ){
                  if( positionX < 0 || positionX >= classWidth ){
                      return false;
                  }

                  if( positionY < 0 || positionY >= classHeight ){
                      return false;
                  }

                  this -> array[ positionY ][ positionX ] = value;

                  return true;
             }

             void print(){
                  for( int iPositionHeight = 0; iPositionHeight < this -> classHeight; iPositionHeight++ ){
                       for( int iPosition = 0; iPosition < this -> classWidth; iPosition++ ){
                                      if( this -> getPoint( iPosition , iPositionHeight ) ){
                                          std::cout << 'X';
                                      }
                                      else{
                                           std::cout << 'O';
                                      }
                       }

                       std::cout << std::endl;
                  }
             }

              std::vector< std::vector< bool > > getArray(){
                return this -> array;
              }

              int getWidth(){
                return this -> classWidth;
              }

              int getHeight(){
                return this -> classHeight;
              }
      private:
              int classWidth;
              int classHeight;

              std::vector< std::vector< bool > > array;

              std::vector< std::vector< bool > > backupFirst;
              std::vector< std::vector< bool > > backupSecond;

};
